SoGeometryShader Class Reference
Shader Classes

The SoGeometryShader class is used for loading geometry shader programs. More...

`#include <Inventor/nodes/SoGeometryShader.h>`

Inheritance diagram for SoGeometryShader:

## Public Types

enum | InputType { POINTS_IN , LINES_IN , TRIANGLES_IN }
enum | OutputType { POINTS_OUT , LINE_STRIP_OUT , TRIANGLE_STRIP_OUT }
Public Types inherited from SoShaderObject
enum | SourceType { ARB_PROGRAM , CG_PROGRAM , GLSL_PROGRAM , FILENAME }
Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoGeometryShader (void)
virtual | ~SoGeometryShader ()
virtual void | GLRender (SoGLRenderAction *action)
Public Member Functions inherited from SoShaderObject
virtual void | search (SoSearchAction *action)
void | updateParameters (SoState *state)
SourceType | getSourceType (void) const
SbString | getSourceProgram (void) const
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | doAction (SoAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SbBool | isSupported (SourceType sourceType)
Static Public Member Functions inherited from SoShaderObject
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFEnum | inputType
SoSFEnum | outputType
SoSFInt32 | maxEmit
Public Attributes inherited from SoShaderObject
SoSFBool | isActive
SoSFEnum | sourceType
SoSFString | sourceProgram
SoMFNode | parameter

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
Protected Member Functions inherited from SoShaderObject
| SoShaderObject (void)
virtual | ~SoShaderObject ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoShaderObject
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoGeometryShader class is used for loading geometry shader programs.

See Shaders in Coin for more information on how to set up a scene graph with shaders.

FILE FORMAT/DEFAULTS:

GeometryShader {
isActive TRUE
sourceType FILENAME
sourceProgram ""
parameter []
inputType TRIANGLES_IN
outputType TRIANGLE_STRIP_OUT
maxEmit 8
}
SoGeometryShader::TRIANGLE_STRIP_OUT
@ TRIANGLE_STRIP_OUT
Definition SoGeometryShader.h:60
SoGeometryShader::outputType
SoSFEnum outputType
Definition SoGeometryShader.h:64
SoGeometryShader::TRIANGLES_IN
@ TRIANGLES_IN
Definition SoGeometryShader.h:54
SoGeometryShader::inputType
SoSFEnum inputType
Definition SoGeometryShader.h:63
SoGeometryShader::maxEmit
SoSFInt32 maxEmit
Definition SoGeometryShader.h:65
SoShaderObject::isActive
SoSFBool isActive
Definition SoShaderObject.h:62
SoShaderObject::parameter
SoMFNode parameter
Definition SoShaderObject.h:67
SoShaderObject::sourceProgram
SoSFString sourceProgram
Definition SoShaderObject.h:64
SoShaderObject::sourceType
SoSFEnum sourceType
Definition SoShaderObject.h:63
SoShaderObject::FILENAME
@ FILENAME
Definition SoShaderObject.h:59

See also
  SoShaderObject
  SoShaderProgram

Since
  Coin 2.5

## Member Enumeration Documentation

## InputType

enum SoGeometryShader::InputType

Enumerates the input types.

Enumerator
POINTS_IN | Shader uses points as input.
LINES_IN | Shader uses lines as input.
TRIANGLES_IN | Shader uses triangles as input. OpenGL will automatically convert quads and polygons into triangles.

## OutputType

enum SoGeometryShader::OutputType

Enumerates the output types.

Enumerator
POINTS_OUT | Shader generates points.
LINE_STRIP_OUT | Shader generates line strips.
TRIANGLE_STRIP_OUT | Shader generates triangle strips.

## Constructor & Destructor Documentation

## SoGeometryShader()

SoGeometryShader::SoGeometryShader | ( | void |  | ) |

Constructor.

## ~SoGeometryShader()

SoGeometryShader::~SoGeometryShader | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoGeometryShader::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoGeometryShader::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoShaderObject.

## getFieldDataPtr()

const SoFieldData ** SoGeometryShader::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoGeometryShader::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoShaderObject.

## GLRender()

void SoGeometryShader::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShaderObject.

## isSupported()

SbBool SoGeometryShader::isSupported | ( | SourceType | sourceType | ) |

static

Returns a boolean indicating whether the requested source type is supported by the OpenGL driver or not.

Beware: To get a correct answer, a valid OpenGL context must be available.

## Member Data Documentation

## inputType

SoSFEnum SoGeometryShader::inputType

The type of geometry used as input to the shader. Default value is TRIANGLES_IN.

## outputType

SoSFEnum SoGeometryShader::outputType

The type of geometry generated from the shader. Default value is TRIANGLE_FAN_OUT.

## maxEmit

SoSFInt32 SoGeometryShader::maxEmit

The maximum number of vertices emitted from the shader. Default value is 8. This corresponds to the GL_GEOMETRY_VERTICES_OUT_EXT enum.

The documentation for this class was generated from the following files:

- SoGeometryShader.h
- SoGeometryShader.cpp